@ECHO OFF

SET TEMP_JLINK=               %TEMP%\create-jre-jlink.tmp
SET TEMP_MODULES_MULTI_LINE=  %TEMP%\create-jre-modules-multi-line.tmp 
SET TEMP_MODULES_SINGLE_LINE= %TEMP%\create-jre-modules-single-line.tmp 

WHERE jlink > %TEMP_JLINK% 2> nul
IF ERRORLEVEL 1 GOTO JLINK_NOT_FOUND
SET /P JLINK_PATH= < %TEMP_JLINK%
CALL :GET_FULL_PATH %JLINK_PATH%\..\..\jmods
SET JMODS_DIR=%TEMP_FULL_PATH%
IF NOT EXIST "%JMODS_DIR%" GOTO JMODS_DIR_NOT_FOUND

jdeps --list-deps %* > %TEMP_MODULES_MULTI_LINE%
type %TEMP_MODULES_MULTI_LINE%
type %TEMP_MODULES_MULTI_LINE% | "%~dp0sed" "/:/d; :a;N;$!ba; s/\n/,/g; s/ //g;" > %TEMP_MODULES_SINGLE_LINE%
SET /P MODULES= < %TEMP_MODULES_SINGLE_LINE%

CALL :GET_OUTPUT_JRE_DIR %JLINK_PATH%\..\..
SET OUTPUT_JRE_DIR=%TEMP_OUTPUT_JRE_DIR%

jlink --compress=2 --no-header-files --no-man-pages --strip-debug --module-path "%JMODS_DIR%" --add-modules %MODULES% --output %OUTPUT_JRE_DIR%

GOTO END

:GET_FULL_PATH
SET TEMP_FULL_PATH=%~f1
EXIT /b

:GET_OUTPUT_JRE_DIR
SET TEMP_A=%~nx1
SET TEMP_OUTPUT_JRE_DIR=jre%TEMP_A:~3%.min
EXIT /b

:JLINK_NOT_FOUND
ECHO file not found: jlink.exe
GOTO END

:JMODS_DIR_NOT_FOUND
ECHO directory not found: %JMODS_DIR% 
GOTO END

:END
DEL %TEMP_JLINK%               > nul 2>&1
DEL %TEMP_MODULES_MULTI_LINE%  > nul 2>&1
DEL %TEMP_MODULES_SINGLE_LINE% > nul 2>&1
